#ifndef lint
static char rcsid[] =
    "@(#) $Header: pqueue.cc,v 1.1.1.1 1996/1/27 03:22:44 bajaj Exp $ (PARC)";
#endif

#define CNOS 12     /* indicates the number of drop prioirity levels, also called
		    classes Class 1 pkts are more important than class 2 and so on*/
#define QNOS 2

#include <string.h>
#include <stdlib.h>
#include "Tcl.h"
#include "queue.h"

/* remove a specific packet, which must be in the queue */
Packet *PacketQueue::getpkt( int level,int off_ip_) {
  for (Packet* p=head_;p!=0;p=p->next_) {
    hdr_ip *iph=(hdr_ip*)p->access(off_ip_);
    if (iph->flowid() == level)
      return p;
  }
}



/*
 * A bounded, priority queue
 */
class PriorityQueue : public Queue {
  //public:
  //PriorityQueue();
protected:
  void 	enque(Packet*);
  Packet* deque();
  PacketQueue q_[QNOS]; //one q for each service priority class
  int thresh_; //threshold value for experimental traffic
  int pktcnt[CNOS]; // pktcount for every drop level
  //  int qlim1_; //qlimit for xtraffic
  int qlim2_;//qlimit for experimental traffic
  int off_ip_;
  int command(int argc, const char*const* argv);
};

/*
PriorityQueue::PriorityQueue()
{
  int i,j;
  for (i=0;i< QNOS;i++) {
    for (j=0; j < CNOS; j++)
      ccount_[i][j]=0;
    othercount_[i]=0;
  }
}
*/

PriorityQueue::PriorityQueue()
{
  int i;
  for (i=0; i < CNOS; i++ ) {
    pktcnt[i]=0;
  }
  // qlim1_=0;
  qlim2_=0;
  bind ("thresh_",&thresh_);
  bind("off_ip_",&off_ip_);
  // bind ("limit1_",&qlim1_);
  bind ("limit2_",&qlim2_);
}



static class PriorityQueueClass : public TclClass {
public:
  PriorityQueueClass() : TclClass("Queue/PriorityQueue") {}
  TclObject* create(int argc, const char*const* argv) {
    return (new PriorityQueue);
	}
} class_priority_queue;


int PriorityQueue::command(int argc, const char*const* argv)
{
  /*
  int level,limit,thresh;
  if (argc == 4) {
    if (strcmp(argv[1], "limit") == 0) {
      level=atoi(argv[2]);
      limit=atoi(argv[3]);
      pktQlimit_[level]=limit;
      return (TCL_OK);
    }
    if (strcmp(argv[1], "limit2") == 0) {
      level=atoi(argv[2]);
      limit=atoi(argv[3]);
      pktQlimit2_[level]=limit;
      return (TCL_OK);
    }
    if (strcmp(argv[1], "thresh") == 0) {
      level=atoi(argv[2]);
      thresh=atoi(argv[3]);
      thresh_[level]=thresh;
      return (TCL_OK);
    }

  }
  */
  return (Queue::command(argc, argv));
}


/*
 * Priority Queue Classifier
 */
void PriorityQueue::enque(Packet* p)
{
  int dlevel,j;
  int sum=0;
  hdr_ip *iph=(hdr_ip*)p->access(off_ip_);

  /*fit in a input drop mechanism here */
  /*compare  the count of all pkts as and more imp as this one
    and if exceeds the limit then drop the current packet */
  q_[0].enque(p);

  dlevel=iph->flowid(); 
  pktcnt[dlevel]++;

  for (j=CNOS-1;j>=0;j--)
    sum += pktcnt[j];


  if (sum > qlim2_) {
    //drop the least imp packet
    for (j=CNOS-1;j>=0;j--)
      if (pktcnt[j]) break;

    pktcnt[j]--;
    p=q_[0].getpkt(j,off_ip_);
    q_[0].remove(p);
    drop(p);
  }
}


Packet* PriorityQueue::deque()
{
  Packet* pkt=0;
  int i,j,dropped=1,dlevel;
  hdr_ip *iph;
  int nonemptyQ=-1;


  /*deque the appropriate pkt */
  //if (q_[1].length() != 0)
  //  return (q_[1].deque());
  // else {
    while (dropped)
      {
	pkt=q_[0].deque();
	dropped=0;
	if (pkt != 0 ) {
	  iph=(hdr_ip*)pkt->access(off_ip_);
	  dlevel=iph->flowid();
	  
	  /* fit in appropriate outgoing drop mech here */
	  pktcnt[dlevel]--;
	  {
	    int k,sum=0;
	    for (k=dlevel-1;k>=0;k--)
	      sum += pktcnt[k];
	    if (sum > thresh_) {
	      /*printf ("dropped due to outgoing drop mecahnism\n");*/
	      drop(pkt);
	      dropped=1;
	    }
	  }
	  
	}
      }
    return pkt;
    //}
}


