Class LayeredSource 

LayeredSource instproc init { addr layers packetsize interval rate ns u type} {
	global ref traffic
	$self instvar layer numlayers baseinterval baserate sim upinterval P
	set baseinterval $interval
	set baserate $rate
	set numlayers $layers
	set upinterval $u
	set P $traffic
	set sim $ns
	set i 1
	while { $i <= $layers } {
		set l [ new Agent/Layer ]
		$l instvar npkts
		set npkts 0
		$l set packetSize_ $packetsize

		#type==1 indicates that setting up a background source with
		#highest priority level
		if { $type == 1} { 
			$l set fid_ 1
			$l set class_ 1
		} else {
			$l set fid_ $i
			$l set class_ $i
		}
		$l set dst_ [ expr $addr + $i - 1]
		
		#Setting up exponential interval
		$l set interval_ [expr $interval/pow(2,$i -1)]
		#$l set interval_ [expr $interval*1.0/$i]
		puts stderr "Printing dst : [$l set dst_] inter : [$l set interval_]"
		set layer($i) $l

		#XXXX HACK for getting a layer by its address
		# so that the receiver may get the total number of packet sent
		# and thus compute utility
		set ref([expr $addr + $i -1]) $l
		incr i
	}
}

LayeredSource instproc start { } {
	$self instvar layer numlayers running_
	set running_ 1
	$self updatepktcnt 
	set i 1
	while { $i <= $numlayers } {
		$layer($i) start
		incr i
	}
}

LayeredSource instproc updatepktcnt {  } {
	$self instvar layer numlayers sim baseinterval baserate upinterval running_ P
	set i 1
	#    set a [exponential $baserate]
	
	set a [uniform 0 1]
	if { $a > [expr 1-1.0/$P] } {
		set pktcnt [expr $P * $baserate +1-$P]
	} else {
		set pktcnt 1
	}
	
	while { $i <= $numlayers && $running_ == 1} {
		$layer($i) instvar npkts 
		$layer($i) set noofpkts_ $pktcnt
		incr npkts [expr int(pow(2,$i-1)*$pktcnt)]
		incr i
	}
	$sim at [ expr [$sim now] + $upinterval] "$self updatepktcnt"
}

LayeredSource instproc stop {} {
	$self instvar layer numlayers running_
	set running_ 0
	set i 1
	while { $i <= $numlayers } {
		$layer($i) stop
		incr i
	}
}

Simulator instproc attach-layers { node src } {
	$src instvar layer numlayers
	set i 1
	while { $i <= $numlayers } {
		$self attach-agent $node $layer($i)
		incr i
	}
}
