#!/import/tcl/sparc-sun-solaris2/bin/tclsh
set nrun 1
set runtime 600.0
set seed 0

proc ls { qType level runno traffic bufs dir proto sources bandwidth} {
	if { $proto == "rlm" } {
		exec ../../ns rlmsims.tcl scenario=0 \
		    qType=$qType level=$level\
		    srcType=lsm bgsrcType=null\
		    runno=$runno sources=$sources bandwidth=$bandwidth\
		    dir=$dir seed=$runno noofbuffers=$bufs\
		    traffic=$traffic delay=0.01\
		    upinterval=1.0 \
		    lsminterval=1.0 statinterval=1\
		    bglevel=0 proto=$proto runtime=600 2>@stderr
	} else {
		exec ../../ns sims.tcl scenario=0 \
		    qType=$qType level=$level\
		    srcType=lsm bgsrcType=null\
		    runno=$runno sources=$sources bandwidth=$bandwidth\
		    dir=$dir seed=$runno noofbuffers=$bufs\
		    traffic=$traffic delay=0.01\
		    upinterval=1.0 \
		    lsminterval=1.0 statinterval=1\
		    bglevel=0 runtime=600 2>@ stderr
	}

}


proc us { qType level runno traffic bufs dir proto sources bandwidth bglevel bgsrcType} {
	if { $proto == "rlm" } {
		exec ../../ns rlmsims.tcl scenario=1 \
		    qType=$qType level=$level\
		    srcType=lsm bgsrcType=$bgsrcType\
		    runno=$runno sources=$sources bandwidth=$bandwidth\
		    dir=$dir seed=$runno noofbuffers=$bufs\
		    traffic=$traffic delay=0.01\
		    upinterval=1.0 \
		    lsminterval=1.0 statinterval=1\
		    bglevel=$bglevel proto=$proto runtime=600 2>@stderr
	} else {
		exec ../../ns sims.tcl scenario=1 \
		    qType=$qType level=$level\
		    srcType=lsm bgsrcType=$bgsrcType\
		    runno=$runno sources=$sources bandwidth=$bandwidth\
		    dir=$dir seed=$runno noofbuffers=$bufs\
		    traffic=$traffic delay=0.01\
		    upinterval=1.0 \
		    lsminterval=1.0 statinterval=1\
		    bglevel=$bglevel runtime=600 2>@ stderr
	}

}


#The list below indicates the burstiness of traffic
set L "1 5"
#the list below indicates buffer size in number of packets
set limits "20 60"

set i 0
while { $i < $argc } {
	set Li [split [lindex $argv $i] =]
	if { [llength $Li] == 2 } {
		set var [lindex $Li 0]
		set val [lindex $Li 1]
		set $var $val
	}
	incr i
}

set sources 8
set bandwidth 4000e3

if { [lindex $argv 0 ] == "avg" } {
	exec gensum [lindex $argv 1] [lindex $argv 2] [lindex $argv 3] [lindex $argv 4] [lindex $argv 5] [lindex $argv 6]
} else {
	set proto [lindex $argv 0]
	set k 1
	while { $k <= $nrun } {
		puts stderr "Run $k"
		foreach d $L {
			set dir "data/$d-a"
			if { $proto == "priority" } {
				set qlist "PriorityQueue PDRR GPDRR"
				foreach q $qlist {    
					set l 1
					while { $l <= 6 } {
						foreach bufs $limits {
							#LS experiments
							#normal
							ls $q $l $k $d $bufs $dir $proto $sources $bandwidth
							#multiplexing
							ls $q $l $k $d [expr $bufs/2] $dir $proto [expr $sources/2] [expr $bandwidth/2]
							#bandwidth
							if { $bufs == 60 } {
								ls $q $l $k $d [expr $bufs/4] $dir $proto $sources [expr $bandwidth/4]
							}

							set bglevel 4
							set bgsrcType lsm
							#US experiments
							#normal
							us $q $l $k $d $bufs $dir $proto $sources $bandwidth $bglevel $bgsrcType
							#multiplexing
							us $q $l $k $d [expr $bufs/2] $dir $proto [expr $sources/2] $bandwidth $bglevel $bgsrcType
							#bandwidth
							if { $bufs == 60 } {
								us $q $l $k $d [expr $bufs/4] $dir $proto $sources [expr $bandwidth/4] [expr $bglevel/2] $bgsrcType
							}
						}
						incr l
					}
					
				}
			}
			if { $proto == "uniform" } {
				set qlist "DropTail DRR RED"
				foreach q $qlist {
					set l 1
					while { $l <= 6 } {
						foreach bufs $limits {
								#LS experiments
							#normal
							ls $q $l $k $d $bufs $dir $proto $sources $bandwidth
							#multiplexing
							ls $q $l $k $d [expr $bufs/2] $dir $proto [expr $sources/2] [expr $bandwidth/2]
							#bandwidth
							if { $bufs == 60 } {
								ls $q $l $k $d [expr $bufs/4] $dir $proto $sources [expr $bandwidth/4]
							}

							set bglevel 4
							set bgsrcType lsm
							#US experiments
							#normal
							us $q $l $k $d $bufs $dir $proto $sources $bandwidth $bglevel $bgsrcType
							#multiplexing
							us $q $l $k $d [expr $bufs/2] $dir $proto [expr $sources/2] $bandwidth $bglevel $bgsrcType
							#bandwidth
							if { $bufs == 60 } {
								us $q $l $k $d [expr $bufs/4] $dir $proto $sources [expr $bandwidth/4] [expr $bglevel/2] $bgsrcType
							}
						}
						incr l
					}
					
				}
				
			
			}
			if { $proto == "rlm" } {
				set qlist "DropTail DRR RED"
				foreach q $qlist {
					foreach bufs $limits {
						#LS experiments
						#normal
						ls $q 7 $k $d $bufs $dir $proto $sources $bandwidth
						#multi
						ls $q 7 $k $d [expr $bufs/2] $dir $proto [expr $sources/2] [expr $bandwidth/2]
						#bandwidth
						if { $bufs==60 } {
							ls $q 7 $k $d [expr $bufs/4] $dir $proto $sources [expr $bandwidth/4]
						}

						#US experiments
						set bgsrcType lsm 
						set bglevel 4
						#normal
						us $q 7 $k $d $bufs $dir $proto $sources $bandwidth $bglevel $bgsrcType
						#multiplexing
						us $q 7 $k $d [expr $bufs/2] $dir $proto [expr $sources/2] $bandwidth $bglevel $bgsrcType
						#bandwidth
						if { $bufs == 60 } {
							us $q 7 $k $d [expr $bufs/4] $dir $proto $sources [expr $bandwidth/4] [expr $bglevel/2] $bgsrcType
						}
					}
				}
			}
		}
		incr k
	}
}	


