#args qType level srcType bgsrcType scenario runno sources bandwidth dir seed noofbuffers traffic delay upinterval statinterval lsminterval bglevel [debug-link]

#lsminterval indicates the timedurations within which the timers are scheduled for sending the burst of packets
#upinterval indicates the timedurations for updating packet counts
#statinterval indicates the timedurations for measurements


# set the number of buffers in ms
set buffers 0.12
set burstylength 760

#SrcModel related stuff
set baserate 4
set lsminterval 0.25

Queue/PDRR set buckets_ 100
Queue/PDRR set mask_ 1
#XXX thresh set based on scenario below


Queue/DRR set mask_ 1
Queue/DRR set buckets_ 100

#Defaults to suppress tcl error messages
Agent/Layer set packetSize_ 0
Agent/Layer set noofpkts_ 0
Agent/Layer set interval_ 0

set seeds(1) 188312339
set seeds(2) 1072664641
set seeds(3) 694388766
set seeds(4) 2009044369
set seeds(5) 934100682
set seeds(6) 1972392646
set seeds(7) 1936856304
set seeds(8) 1598189534
set seeds(9) 1822174485
set seeds(10) 1871883252

set packetSize 1000
set random 1
set starttime 0.0
set runtime 600.0
set statinterval 1
set rcvtime 160.0

set a 0
#set seed -1

set i 0
while { $i < $argc } {
	set L [split [lindex $argv $i] =]
	if { [llength $L] == 2 } {
		set var [lindex $L 0]
		set val [lindex $L 1]
		set $var $val
	}
	incr i
}

puts stderr $noofbuffers

if [ info exists debug-link] { 
    set f [open out.tr w]
}

#if { $seed >= 0 } {
#	puts stderr [ns-random $seed]
#}
ns-random $seeds($seed)
$defaultRNG seed $seeds($seed)

Queue/DropTail set limit_ [expr int($buffers*$bandwidth/(8*$packetSize))]
Queue/PriorityQueue set limit2_ [expr int($buffers*$bandwidth/(8*$packetSize))]
Queue/PriorityQueue set thresh_  [expr int([Queue/PriorityQueue set limit2_] *0.6)]
Queue/DRR set blimit_ [expr int($buffers*$bandwidth/8)]
Queue/DRR set quantum_ $packetSize
Queue/PDRR set blimit_ [expr int($buffers*$bandwidth/8)]
Queue/PDRR set quantum_ $packetSize
Queue/PDRR set thresh_ [expr int([Queue/PDRR set blimit_] *0.6/$sources)]
Queue/GPDRR set quantum_ $packetSize
Queue/GPDRR set mask_ 1
Queue/GPDRR set buckets_ 100



#if { $lag == 1 }  {
#    set kind lag
#} else {
#    if  { $utilfunc == "non-linear-loss" } {
#	set kind nonlin
#    } else {
#	set kind normal
#    }
#}
			
set outfilename "$dir/$qType-$srcType-$bgsrcType-$level-$noofbuffers-$runno"	
set plots [open $outfilename w]
set qType $qType

set ns [new Simulator]
#$ns use-scheduler Calendar
#source fqutil.tcl

Class LossTrace -superclass Agent/LossMonitor
LossTrace instproc init { sim interval } {
    $self next
    $self instvar lastlost lastpkts sumutil sumtime util data nlost_ npkts_

    set lastlost 0
    set lastpkts 0
    set sumutil 0
    set sumtime 0

    set nlost_ 0 
    set npkts_ 0
}

source layers.tcl

Simulator instproc mknod nn {
    $self instvar node
    if ![info exists node($nn)] {
	set node($nn) [$self node]
    }
}

Simulator instproc mklnk { n1 n2 bw delay qType } {
    global f buffers packetSize sources noofbuffers bandwidth
    $self instvar node
    $self mknod $n1
    $self mknod $n2


    if { $bw != $bandwidth } {	
	Queue set limit_ [expr int($buffers*$bw/(8*$packetSize))]
	Queue/PriorityQueue set limit2_ [expr int($buffers*$bw/(8*$packetSize))]
	Queue/DropTail set limit_ [expr int($buffers*$bw/(8*$packetSize))]
	Queue/DRR set blimit_ [expr int($buffers*$bw/8)]
	Queue/PDRR set blimit_ [expr int($buffers*$bw/8)]
	Queue/GPDRR set blimit_ [expr int($buffers*$bw/8)]
    } else {
	Queue set limit_ $noofbuffers
	Queue/PriorityQueue set limit2_ $noofbuffers
	Queue/DropTail set limit_ $noofbuffers
	Queue/DRR set blimit_ [expr $noofbuffers*$packetSize]
	Queue/PDRR set blimit_ [expr $noofbuffers*$packetSize]
	Queue/GPDRR set blimit_ [expr $noofbuffers*$packetSize]
    }
    Queue/PriorityQueue set limit2_ [expr int($buffers*$bw/(8*$packetSize))]
    Queue/PriorityQueue set thresh_  [expr int([Queue/PriorityQueue set limit2_]*0.6)]

	Queue/RED set maxthresh_ [expr int([Queue set limit_])]
	Queue/RED set thresh_ [expr int([Queue/RED set maxthresh_]/3)]
	Queue/RED set mean_pktsize_ $packetSize
	Queue/RED set q_weight_ 0.002
	Queue/RED set linterm_ 10
	Queue/RED set drop-tail_ false
	
	Queue/DRR set quantum_ $packetSize
	Queue/PDRR set quantum_ $packetSize
	Queue/PDRR set thresh_ [expr int([Queue/PDRR set blimit_] *0.6/$sources)]
	Queue/GPDRR set thresh_ [expr int([Queue/GPDRR set blimit_] *0.6)]
	
	$self duplex-link $node($n1) $node($n2) $bw $delay $qType
	if { $n1 == 0  && $n2 == 1 } {
		if [ info exists f ] {
			$self trace-queue $node(0) $node(1) $f
		}
	}
	
}

Simulator instproc create-lsm { layers baserate nn rcvrType type} {
    global packetSize lsminterval starttime runtime rcvtime statinterval upinterval a
    $self instvar node

	set lsm [new LayeredSource 0 $layers $packetSize $lsminterval $baserate $self $upinterval $type]
	
	
	$self attach-layers $node($nn) $lsm
	set r [expr 60. + double([ns-random] % 10000000) / 1e7 * 60]
	puts stderr $r
	$self at $r "$lsm start"
	$self at $runtime "$lsm stop"
	
	$lsm instvar layer
	set i 1
	while { $i <= $layers } {
		set rcvr [$self create-receiver 1 $rcvrType]
		$rcvr instvar init address
		set init $rcvtime
		set address [expr $a + $i -1]
		$self connect $layer($i) $rcvr
		$self at $rcvtime "$layer($i) set npkts 0"
		$self at $rcvtime "$rcvr get-stats $self $statinterval"
		#XXX Hack to get the right number of total pkts
		$self at [expr $runtime-0.001] "get-total-pkts $i $rcvr $layer($i)"
		incr i
	}
	incr a 32
}

proc get-total-pkts { i rcvr sender } {
	$sender instvar npkts
	$rcvr instvar totalpkts
	set totalpkts $npkts
	puts stderr "$i : $npkts "
}

Simulator instproc create-CBR-agent { node addr fid rate packetSize random  starttime runtime rcvrType r } {
	
	global statinterval plots qType priority rcvtime
	puts stderr "Creating a CBR agent"
	set cbr [new Agent/CBR]
	$self attach-agent $node $cbr
	$cbr set packetSize_ $packetSize
	$cbr set interval_ [expr $packetSize * 8/$rate]
	$cbr set fid_ $fid
	
	if [ info exists priority ] {
		$cbr set prio_ $priority
	}
	
	$cbr set random_ 1
	set rcvr [ $self create-receiver 1 $rcvrType ]
	$rcvr instvar address init sumtime
	set address $addr
	$self connect $cbr $rcvr
	set init $rcvtime
	$self at $rcvtime "$rcvr get-stats $self $statinterval"
	$self at $r "$cbr start"
	$self at $runtime  "$cbr stop"
}

Simulator instproc create-bursty-agent2 { nn addr fid rate packetSize starttime runtime rcvrType r time } {

    global statinterval priority rcvtime
    $self instvar node
    set src [new Agent/CBR/UDP]
    $src set fid_ $fid

    $src set packetSize_ $packetSize
    $self attach-agent $node($nn) $src

    set exp1 [new Traffic/Expoo]
    $exp1 set packet-size $packetSize
    $exp1 set burst-time 100ms
    $exp1 set idle-time 100ms
    $exp1 set rate $rate

    $src attach-traffic $exp1
    set rcvr [$self create-receiver 1 $rcvrType]
    $rcvr instvar address init sumtime

    set address $addr
    $self connect $src $rcvr

    set init $rcvtime
    $self at $rcvtime  "$src set seqno_ -1"
    $self at $rcvtime "$rcvr get-stats $self $statinterval"
    $self at $r "$src start"
    $self at $runtime  "$src stop"
    $self at [expr $runtime -0.001] "update-burstysnd-pktcnt $rcvr $src"
}

proc update-burstysnd-pktcnt { rcvr sender } {
    $sender instvar seqno_
    $rcvr instvar totalpkts
    set totalpkts $seqno_
}


Simulator instproc create-bursty-agent { node addr fid rate packetSize starttime runtime rcvrType r time } {
    global statinterval priority rcvtime
    set src [new Agent/CBR/UDP]
    $src set fid_ $fid
    if [ info exists priority ] {
	$src set prio_ $priority
    }
    $src set packetSize_ $packetSize
    $self attach-agent $node $src
    
    set tfile [ new TraceSyncFile]
    $tfile filename $rate
    
    set trace [ new Traffic/SyncTrace ]
    $trace attach-tracefile $tfile $time

    $src attach-traffic $trace
#    $trace srcagent $src
#    $src srcmdl $trace
    
    set rcvr [$self create-receiver 1 $rcvrType]
    $rcvr instvar address init sumtime
#    puts stderr $sumtime
    set address $addr
    $self connect $src $rcvr

#    set r [expr 60. + double([ns-random] % 10000000) / 1e7 * 60]
#    set r 0.
#    puts stderr "Setting fid for bursty source to [$src set fid_]"
    set init $rcvtime
    $self at $rcvtime "$rcvr get-stats $self $statinterval"
    $self at $r "$src start"
    $self at $runtime  "$src stop"
}
    

Simulator instproc create-layered-source  { nn rates fid rcvrType} {
    global packetSize random starttime runtime srcType burstylength
    $self instvar node
    set i 0
    set time [expr [ns-random] % 100000 / 1e5 * $burstylength ]
    set when [expr 60. + double([ns-random] % 10000000) / 1e7 * 60]
    foreach r $rates {
	#fix the fid parameter passed here
	$self create-single-source $srcType $nn $i $r $i  $rcvrType $when $time
	incr i
    }
}

# XXX for creating cross traffic sources
Simulator instproc create-single-source { srcType nn addr rate fid rcvrType when time } {
    global packetSize random starttime runtime  
    $self instvar node
    if { $srcType == "cbr" } {
	$self create-CBR-agent $node($nn) $addr $fid $rate $packetSize $random $starttime $runtime $rcvrType $when
	} else {
	    $self create-bursty-agent $node($nn) $addr $fid $rate $packetSize $starttime $runtime $rcvrType $when $time
	}
}

Simulator instproc create-receiver { nn rType } {
    global statinterval
    $self instvar node
    set rcvr [new $rType $self $statinterval ]
    $rcvr instvar sumtime 
    $self attach-agent $node($nn) $rcvr
    return $rcvr
}


if { $scenario == 1 }  {
    if { $bgsrcType == "bursty" } {
#	set bgrates "vicdata/vic.2.trunc vicdata/vic.4.trunc vicdata/vic.8.trunc vicdata/vic.16.trunc"
	set bgrates 6000e3
    } 
    if { $bgsrcType == "cbr" } {
	set bgrates "32e3 64e3 128e3 256e3"
    }

    $ns mklnk 0 1 $bandwidth $delay $qType
    $ns mklnk 2 0 10e6 0.01 $qType

    # create a layered source
    if {$srcType == "lsm" } {
	$ns create-lsm $level $baserate 2 LossTrace 0
    } else {
	$ns create-layered-source 2 $rates 0 LossTrace 
    }


    set i 3
    while { $i  < [ expr $sources + 2 ] } {
	set when [expr 60. + double([ns-random] % 10000000) / 1e7 * 60]
	$ns mklnk $i 0 10e6 0.01 $qType

	set time 0
	if { $bgsrcType == "lsm" } {
	    	$ns create-lsm $bglevel $baserate $i LossTrace 0
	} else {
	    #	    foreach singlesrcType $bgrates {
	    #		$ns create-single-source $bgsrcType $i [expr $i + 5] $singlesrcType 0 LossTrace $when $time
	    #	    }
	    $ns create-bursty-agent2 $i 32 1 $bgrates $packetSize $starttime $runtime LossTrace $when $time
	}
	incr i
	
    }
} else {
    $ns mklnk 0 1 $bandwidth $delay $qType
    set i 2
    while { $i < [expr $sources + 2] } { 
	$ns mklnk $i 0 10000e3 0.01 $qType
	if { $srcType == "lsm" } {
	    $ns create-lsm  $level $baserate $i LossTrace 0
	} else {
	    $ns create-layered-source $i  $rates [expr $i - 2] LossTrace
	}
	incr i
    }
}

 
proc compute-recv-fraction { npkts lastpkts layerno } {
    return [expr $npkts-$lastpkts]
}

LossTrace instproc get-stats-now { time } {
    global runtime statinterval plots utilfunc flag 
    $self instvar sumtime sumutil nlost_ npkts_ totalpkts lastlost lastpkts address

    if {!  [ info exists utilfunc ] } {
	set utilfunc trivial-loss-util
    }

	set frac [compute-recv-fraction $npkts_ $lastpkts $address]
	set sumutil [expr $sumutil + $frac]	

	#write the final stats
        if { $time >= $runtime && $flag($address) ==0} {
	puts $plots "$address 0 $time $sumtime $frac [expr $sumutil*1.0/$totalpkts] $nlost_ $npkts_ $lastlost $lastpkts $sumutil $totalpkts"
#	puts $plots "$address 0 $time $sumtime $frac $nlost_ $npkts_ $lastlost $lastpkts $sumutil"
	flush $plots
	set flag($address) 1
 }

    incr sumtime 
    set lastlost $nlost_
    set lastpkts $npkts_ 

}

LossTrace instproc get-stats { sim interval } {
    global plots flag
    $self instvar init sumtime nlost_ npkts_ expected_ address
    if { [ $sim now ] != $init } {
	$self get-stats-now [$sim now] 
    } else {
	incr sumtime
	set nlost_ 0
	set npkts_ 0
	set expected_ -1
	set flag($address) 0
    }
    $sim at  [expr [$sim now] + $interval] "$self get-stats $sim $interval"
}


$ns at [expr $runtime + 1 ] "finish"


proc finish {} {
    global plots outfilename level qType srcType scenario bgsrcType delay runno noofbuffers dir
    puts "processing output ..."
    if { $bgsrcType == "null" } {
	exec awkfile0 $outfilename $dir/$qType-$srcType-$bgsrcType-$level-$delay-$noofbuffers-$runno
    } else {
	exec awkfile $outfilename $dir/$qType-$srcType-$bgsrcType-$level-$delay-$noofbuffers-$runno
    }
    if [ info exists plots ] {
	close $plots
    }
    if [ info exists f ] {
	close $f
    }
    exit}

#
$ns run

